#include "asf.h"
#include "ceos.h"
#include "metadisplay.h"

char *sprn_esa_facdr(struct ESA_FACDR *f)
{
  char *ret = MALLOC(sizeof(char)*1);
  strcpy(ret, "");

  add(&ret, "\n********* begin of Facility related data (ESA) record ********\n");
  add(&ret, "Date of last release of QC software (not relavent for RAW product) = %s\n", f->qc_release);
  add(&ret, "Date of the last calibration update <YYMMDD> (not relavent for RAW product) = %s\n", f->cal_update);
  add(&ret, "Overall QA summary flag (Sum of the 9 following flags) = %d\n", f->qa_flag);
  add(&ret, "PRF code change flag (0 = PRF constant in scene) = %d\n", f->prf_flag);
  add(&ret, "Sampling window start time change flag (0: SWST constant) = %d\n", f->samp_flag);
  add(&ret, "Cal. system & receiver gan change flag (0: Cal/Rx gain constant) = %d\n", f->cal_flag);
  add(&ret, "Chirp replica quality flag (0: Replica XCF in limits) = %d\n",f->chirp_flag);
  add(&ret, "Input data statistics flag (0: Raw data mean & sd in limits) = %d\n",f->data_flag);
  add(&ret, "Doppler centroid confidence measure flag (0: in limits) = %d\n",f->dop_conf_flag);
  add(&ret, "Doppler centroid value (0: Dopp-centroid less than PRF/2) = %d\n",f->dop_val);
  add(&ret, "Doppler ambiguity confidence measure flag (0: in limits) = %d\n",f->dop_amb_conf_flag);
  add(&ret, "Output data Mean flag (0: Image mean or sd in limits) = %d\n",f->out_flag);
  add(&ret, "On ground / on board range compressed flag (0: OGRC, 1: OBRC) = %d\n",f->range_flag);
  add(&ret, "Number of PRF code changes = %d\n",f->n_prf_changes);
  add(&ret, "Number of sampling window time changes = %d\n",f->n_samp_changes);
  add(&ret, "Number of calibration subsystems gain changes = %d\n",f->n_gain_changes);
  add(&ret, "Number of missing lines (i.e. raw data input lines) = %d\n",f->n_miss_lines);
  add(&ret, "Number of receiver gain changes = %d\n",f->n_rec_gain_changes);
  add(&ret, "3-dB width of Cross Correlation Function (CCF) between 1st extracted and nominal chirp = %.7f\n",f->width_ccf);
  add(&ret, "First side lobe level of chirp CCF = %.7f\n",f->lobe_ccf);
  add(&ret, "ISLR of chirp CCF = %.7f\n",f->islr);
  add(&ret, "Doppler centroid confidence measure (0: best; 1: worst) = %.7f\n",f->dop_cent_conf);
  add(&ret, "Doppler ambiguity confidence measure (0: best; 1: worst) = %.7f\n",f->dop_amb_conf);
  add(&ret, "Estimated mean of I input data (once the nominal bias of 15.5 has been applied) = %.7f\n",f->main_i);
  add(&ret, "Estimated mean of Q input data (once the nominal bias of 15.5 has been applied) = %.7f\n",f->main_q);
  add(&ret, "Estimated standard deviation of I input data = %.7f\n",f->stddev_i);
  add(&ret, "Estimated standard deviation of Q input data = %.7f\n",f->stddev_q);
  add(&ret, "Calibration system gain of first processed line (telemetry value) = %.7f\n",f->cal_gain);
  add(&ret, "Receiver gain of first processed line (telemetry value) = %.7f\n",f->rec_gain);
  add(&ret, "Doppler ambiguity number = %.7f\n",f->dop_amb);
  add(&ret, "Bias correction applied to I channel (to be added to the nominal bias) = %.7f\n",f->bias_i);
  add(&ret, "Bias correction applied to Q channel (to be added to the nominal bias) = %.7f\n",f->bias_q);
  add(&ret,"I/Q gain imbalance correction (applied to I channel) = %.7f\n",f->gain_i);
  add(&ret,"I/Q gain imbalance correction (applied to Q channel) = %.7f\n",f->gain_q);
  add(&ret,"I/Q non-orthogonality correction (applied to Q channel) = %.7f\n",f->non_ortho);
  add(&ret,"Noise power per sample (Not provided by the VMP) = %.7f\n",f->noise_pow);
  add(&ret,"Calibration pulse time delay (Not provided by the VMP) = %s\n",f->pulse_delay);
  add(&ret,"Number of valid calibration pulses (0 for the VMP) = %d\n",f->n_cal_pulses);
  add(&ret,"Number of valid noise pulses (0 for the VMP) = %d\n",f->n_noise_pulses);
  add(&ret,"Number of valid replica pulses = %d\n",f->n_rep_pulses);
  add(&ret,"First sample in replica (Chirp extraction index) = %.7f\n",f->f_samp_rep);
  add(&ret,"Mean calibration pulse power (Not provided by the VMP) = %.7f\n",f->cal_pulse_pow);
  add(&ret,"Mean noise pulse power (Not provided by the VMP) = %.7f\n",f->noise_pulse_pow);
  add(&ret,"Range compression normalisation factor = %.7f\n",f->range_comp);
  add(&ret,"Replica pulse power = %.7f\n",f->rep_pulse_pow);
  add(&ret,"Incidence angle at first range pixel (at mid-azimuth) = %.7f\n",f->inc_first_pix);
  add(&ret,"Incidence angle at center range pixel (at mid-azimuth) = %.7f\n",f->inc_center_pix);
  add(&ret,"Incidence angle at last range pixel (at mid-azimuth) = %.7f\n",f->inc_last_pix);
  add(&ret,"Slant range reference (for range spreading loss compensation) = %.7f\n",f->sl_range_ref);
  add(&ret,"Antenna pattern correction flag (0: no correction) = %d\n",f->ant_pattern_flag);
  add(&ret,"Absolute calibration constant K (scalar) (Not provided for the RAW product) = %.7f\n",f->abs_cal_const);
  add(&ret,"Upper bound calibration constant K (+0.75dB) (Not provided for the RAW product) = %.7f\n",f->up_cal_const);
  add(&ret,"Lower bound calibration constant K (-0.75dB) (Not provided for the RAW product) = %.7f\n",f->low_cal_const);
  add(&ret,"Estimated noise equivalent sigma0 (Not provided for the RAW product) = %.7f\n",f->sigma_0);
  add(&ret,"Date on which K was generated as YYMMDD (Not provided for the RAW product) = %s\n",f->k_gen);
  add(&ret,"K version number as XXYY (Not provided for the RAW product) = %s\n",f->k_ver);
  add(&ret,"Number of duplicated input lines (Not provided by the VMP) = %d\n",f->dup_lines);
  add(&ret,"Estimated bit error rate (Not provided by the VMP) = %.7f\n",f->ber);
  add(&ret,"Output image mean (Not provided for the RAW product) = %.7f\n",f->img_mean);
  add(&ret,"Output image standard deviation (Not provided for the RAW product) = %.7f\n",f->img_std_dev);
  add(&ret,"Output image maximum value (Not provided for the RAW product) = %.7f\n",f->img_max);
  add(&ret,"Time of raw data first input range line (UTC) <dd-MMM-yyyy hh:mm:ss.ttt> = %s\n",f->t_first_line);
  add(&ret,"Time of ascending node state vector (UTC) = %s\n",f->t_asc_node);
  add(&ret,"Ascending node state vector X = %.15f\n",f->x_asc_pos);
  add(&ret,"Ascending node state vector Y = %.15f\n",f->y_asc_pos);
  add(&ret,"Ascending node state vector Z = %.15f\n",f->z_asc_pos);
  add(&ret,"Ascending node state vector X' = %.15f\n",f->x_asc_vel);
  add(&ret,"Ascending node state vector Y' = %.15f\n",f->y_asc_vel);
  add(&ret,"Ascending node state vector Z' = %.15f\n",f->z_asc_vel);
  add(&ret,"Output pixel bit length = %d\n",f->out_bits);
  add(&ret,"Processor gain #1 = %.7f\n",f->gain1);
  add(&ret,"Processor gain #2 = %.7f\n",f->gain2);
  add(&ret,"Processor gain #3 = %.7f\n",f->gain3);
  add(&ret,"Peak location of Cross Correlation Function (CCF) between first extracted and nominal chirp = %d\n",f->peak_loc_first);
  add(&ret,"3-dB width of Cross Correlation Function (CCF) between last extracted and nominal chirp = %.7f\n",f->width_ccf2);
  add(&ret,"First side lobe level of chirp CCF between last extracted chirp and nominal chirp = %.7f\n",f->f_lobe);
  add(&ret,"ISLR of chirp CCF between last extracted chirp and nominal chirp = %.7f\n",f->islr_ccf);
  add(&ret,"Peak location of Cross Correlation Function (CCF) between last extracted chirp and nominal chirp = %d\n",f->peak_loc_last);
  add(&ret,"Roll tilt mode flag (0: not in roll tilt mode) = %d\n",f->roll_flag);
  add(&ret,"Raw data correction flag (0: correction with defaults parameters) = %d\n",f->raw_data_flag);
  add(&ret,"Look detection flag (1 = power detected and summed) (Not provided) = %d\n",f->look_flag);
  add(&ret,"Doppler ambiguity estimation flag (0: no estimation done) (Not provided) = %d\n",f->dop_amb_flag);
  add(&ret,"Azimuth baseband conversion flag (0: no conversion done) (Not provided) = %d\n",f->az_base_flag);
  add(&ret,"Samples per line used for the raw data analysis = %d\n",f->samp_per_line);
  add(&ret,"Range lines skip factor for raw data analysis = %d\n",f->lines_skip);
  add(&ret,"Time of input state vector (UTC) used to processed the image <dd-MMM-yyyy hh:mm:ss.ttt> = %s\n",f->t_in_stvec);
  add(&ret,"Input state vector - Position vector X = %.15f\n",f->x_in_pos);
  add(&ret,"Input state vector - Position vector Y = %.15f\n",f->y_in_pos);
  add(&ret,"Input state vector - Position vector Z = %.15f\n",f->z_in_pos);
  add(&ret,"Input state vector - Velocity vector X' = %.15f\n",f->x_in_vel);
  add(&ret,"Input state vector - Velocity vector Y' = %.15f\n",f->y_in_vel);
  add(&ret,"Input state vector - Velocity vector Z' = %.15f\n",f->z_in_vel);
  add(&ret,"Input state vector type flag (0: predicted orbit; 1: preliminary or precise) = %d\n",f->in_stvec_flag);
  add(&ret,"Window coefficient for range-matched filter = %.7f\n",f->range_filt);
  add(&ret,"Window coefficient for azimuth-matched filter = %.7f\n",f->az_filt);
  add(&ret,"Update period of range-matched filter = %d\n",f->update_filt);
  add(&ret,"Look scalar gain 1 = %.7f\n",f->look_gains[0]);
  add(&ret,"Look scalar gain 2 = %.7f\n",f->look_gains[1]);
  add(&ret,"Look scalar gain 3 = %.7f\n",f->look_gains[2]);
  add(&ret,"Look scalar gain 4 = %.7f\n",f->look_gains[3]);
  add(&ret,"Look scalar gain 5 = %.7f\n",f->look_gains[4]);
  add(&ret,"Look scalar gain 6 = %.7f\n",f->look_gains[5]);
  add(&ret,"Look scalar gain 7 = %.7f\n",f->look_gains[6]);
  add(&ret,"Look scalar gain 8 = %.7f\n",f->look_gains[7]);
  add(&ret,"Sampling window start time bias = %d\n",f->samp_win_bias);
  add(&ret,"Doppler centroid cubic coefficient = %.15f\n",f->dop_cube_coef);
  add(&ret,"PRF code of first range line (telemetry value) = %d\n",f->prf_first_line);
  add(&ret,"PRF code of last range line (telemetry value) = %d\n",f->prf_last_line);
  add(&ret,"Sampling window start time code of first range line (telemetry value) = %d\n",f->win_first_line);
  add(&ret,"Sampling window start time code of last range line (telemetry value) = %d\n",f->win_last_line);
  add(&ret,"Calibration system gain of last processed line (telemetry value) = %d\n",f->cal_gain_last_line);
  add(&ret,"Receiver gain of last processed line (telemetry value) = %d\n",f->rec_gain_last_line);
  add(&ret,"First processed range sample = %d\n",f->first_range_samp);
  add(&ret,"Azimuth FFT/IFFT ratio ( Not relevant for the RAW product) = %d\n",f->fft_ratio);
  add(&ret,"Number of azimuth blocks processed (0000 for the RAW product) = %d\n",f->n_az_blocks);
  add(&ret,"Number of input raw data lines (variable) = %d\n",f->n_in_lines);
  add(&ret,"Initial Doppler ambiguity number = %d\n",f->ini_dop_amb);
  add(&ret,"Chirp quality thresholds\n");
  add(&ret,"\tPulse width of the chirp CCF = %.7f\n",f->chirp_quality[0]);
  add(&ret,"\tFirst sidelobe of the chirp CCF = %.7f\n",f->chirp_quality[1]);
  add(&ret,"\tISLR of the chirp CCF = %.7f\n",f->chirp_quality[2]);
  add(&ret,"Input data statistic thresholds\n");
  add(&ret,"\tMean of input I data in fraction of maximum absolute of input data = %.7f\n",f->in_data_stats[0]);
  add(&ret,"\tMean of input Q data in fraction of maximum absolute of input data = %.7f\n",f->in_data_stats[1]);
  add(&ret,"\tStd dev of input I data in fraction of maximum absolute of input data = %.7f\n",f->in_data_stats[2]);
  add(&ret,"\tStd dev of input Q data in fraction of maximum absolute of input data = %.7f\n",f->in_data_stats[3]);
  add(&ret,"Doppler ambiguity confidence threshold 1 = %.7f\n",f->dop_amb_thres[0]);
  add(&ret,"Doppler ambiguity confidence threshold 2 = %.7f\n",f->dop_amb_thres[1]);
  add(&ret,"Output data statistic thresholds\n");
  add(&ret,"\tMean of output data = %.7f\n",f->out_data_stats[0]);
  add(&ret,"\tStandard deviation of output data = %.7f\n",f->out_data_stats[1]);
  add(&ret,"Satellite binary time of first range line (telemetry value) (Not provided by the VMP) = %s\n",f->t_sat_first_line);
  add(&ret,"Number of valid pixels per range line (the remaining pixels are zero padded) = %d\n",f->n_val_pix);
  add(&ret,"Number of range samples discarded during processing interpolations = %d\n",f->n_range_samp);
  add(&ret,"I/Q gain imbalance - Lower bound = %.7f\n",f->gain_low);
  add(&ret,"I/Q gain imbalance - Upper bound = %.7f\n",f->gain_up);
  add(&ret,"I/Q quadrature departure - Lower bound = %.7f\n",f->quad_low);
  add(&ret,"I/Q quadrature departure - Upper bound = %.7f\n",f->quad_up);
  add(&ret,"3-dB look bandwidth (Not relevant for the RAW product) = %.7f\n",f->look_bw);
  add(&ret,"3-dB processed Doppler bandwidth (Not relevant for the RAW product) = %.7f\n",f->dop_bw);
  add(&ret,"Range spreading loss compensation flag (0 = no compensation) = %d\n",f->range_spread);
  add(&ret,"Datation flag (1 = azimuth timing improved based on 'format number' field two lines below) = %d\n",f->datation_flag);
  add(&ret,"Maximum error of range line timing = %d\n",f->max_error_rng_time);
  add(&ret,"Format number of range line used to synchronize the azimuth timing = %d\n",f->fmt_num);
  add(&ret,"Automatic look scalar gain flag (1: automatically calculated) = %d\n",f->look_gain_flag);
  add(&ret,"Maximum value of look scalar gain before the look scalar gains are normalised (Not provided) = %d\n",f->max_look);
  add(&ret,"Replica normalization method flag (0: via replica power; 1: via the square root of replica power) = %d\n",f->rep_norm_flag);
  add(&ret,"Coefficient 1 of the ground range to slant range conversion polynomial (Not provided) = %20.10e\n",f->gr2sr_poly[0]);
  add(&ret,"Coefficient 2 of the ground range to slant range conversion polynomial (Not provided) = %20.10e\n",f->gr2sr_poly[1]);
  add(&ret,"Coefficient 3 of the ground range to slant range conversion polynomial (Not provided) = %20.10e\n",f->gr2sr_poly[2]);
  add(&ret,"Coefficient 4 of the ground range to slant range conversion polynomial (Not provided) = %20.10e\n",f->gr2sr_poly[3]);
  add(&ret,"Coefficient 1 of the antenna elevation pattern polynomial (Not provided) = %20.10e\n",f->ant_elev_poly[0]);
  add(&ret,"Coefficient 2 of the antenna elevation pattern polynomial (Not provided) = %20.10e\n",f->ant_elev_poly[1]);
  add(&ret,"Coefficient 3 of the antenna elevation pattern polynomial (Not provided) = %20.10e\n",f->ant_elev_poly[2]);
  add(&ret,"Coefficient 4 of the antenna elevation pattern polynomial (Not provided) = %20.10e\n",f->ant_elev_poly[3]);
  add(&ret,"Coefficient 5 of the antenna elevation pattern polynomial (Not provided) = %20.10e\n",f->ant_elev_poly[4]);
  add(&ret,"Range time of origin of antenna pattern polynomial (Not provided) = %16.7e\n",f->range_time_poly);
  add(&ret, "\n********* end of Facility related data (ESA)  record *********\n");
  return ret;
}

void prn_esa_facdr(FILE *fp, struct ESA_FACDR *f)
{
    char *rec = sprn_esa_facdr(f);
    fprintf(fp, "%s", rec);
    FREE(rec);
}
